//////////////////////////////////////////////////////////////////////
//                                                                  //
//  Nathan Balon                                                    //
//  SN #3210 1717                                                   //
//                                                                  //
//  Program #3                                                      //
//  CIS 310                                                         //
//  Winter 2004                                                     //
//                                                                  //
//  BigNumber1.cpp: implementation of the BigNumber class.          //
//                                                                  //
//////////////////////////////////////////////////////////////////////


#include "BigNumber1.h"
#include <iostream>
using namespace std;

#define LINE_SIZE 83               // max size of line read in                

/////////////////////////////////////////////////////////////////////
//                                                                 //
//   Constructor for BigNumber class. The constructor take one     //
//   argument a string containing the line read from a file and    //
//   parses the string and set the 2 operands and the operator.    //
//                                                                 //
/////////////////////////////////////////////////////////////////////

BigNumber::BigNumber(char *line){
	int char_count = 0;			// # of characters read from the line					
	int temp[OP_SIZE];			// temporay array
	int op1_count = 0;			// # of digits in operand1
	int op2_count = 0;			// # of digits in operand2
	int count = 0;
	int i = 0;

	// initialize the arrays to all 0's
    for(i = 0; i < OP_SIZE; i ++){
        operand1[i] = 0;
        operand2[i] = 0;
		result[i] = 0;
		temp[i] = 0;
    }

	// check if an operator is found
	for(char_count = 0; char_count < LINE_SIZE; char_count++){
        if((line[char_count] == '+') || (line[char_count] == '-')
			|| (line[char_count] == '*') || (line[char_count] == '/')
			|| (line[char_count] == '$')){ 
             op =line[char_count];      // set the operator
             char_count++;				
             break;
        }
		// if an operator is not found add the digit to operand1
        else{
            temp[char_count] = hex_to_dec(line[char_count]);
			op1_count++;
        }
    }
	
	op1_size = op1_count;		// save the size of operand1
	count = op1_count;			// set count to the # of hex digits

	// reverse the order of operand2
	for(i = 0; i < count; i++){
		operand1[--op1_count] = temp[i];
	}

	// reset the temp array to 0 
    for(i = 0; i < OP_SIZE ; i ++){
		temp[i] = 0;
    }

	// get the second operand
    for(int j = 0; j < OP_SIZE + 1; char_count++, j++){
        // check for an '=' for the end of second operand
		if(line[char_count] == '='){
			break;
       }
        // get the next character for the second operand
        else{
            temp[j] = hex_to_dec(line[char_count]);
			op2_count++;
        }

    }   

	op2_size = op2_count;        // save the size of operand2
	count = op2_count;           // set count to the number of hex digits
	
	// resverse the order of operand2
	for(i = 0; i < count; i++){
		operand2[--op2_count] = temp[i];
	}
}

BigNumber::~BigNumber(){

}

/////////////////////////////////////////////////////////////////////
//                                                                 //
//  Method: operation() calls the correct function to either: add, //
//  subtact, multiply, divide or take the power of the operands.   // 
//                                                                 //
/////////////////////////////////////////////////////////////////////

void BigNumber::operation(){
    switch(op){
		case '+':
			add();
            break;
        case '-':
            subtract();
            break;
        case '*':
			multiply();
            break;
        case '/':
			divide();
            break;
        case '$':
			power();
            break;
    }
}

/////////////////////////////////////////////////////////////////////
//                                                                 //
//  Method: add(), adds the operand1 and operand2 together         //
//                                                                 //
/////////////////////////////////////////////////////////////////////

void BigNumber::add(){
	int carry = 0;				// carry from previous operation	

	for(int i = 0; i < OP_SIZE; i++){
		if((operand1[i] + operand2[i] + carry) > 15){
			result[i] = operand1[i] + operand2[i] + carry;
			result[i] = result[i] % 16;
			carry = 1;
		}		
		else if((operand1[i] + operand2[i] + carry) <= 15){
			result[i] = (operand1[i] + operand2[i] + carry);
			carry = 0;
		}
	}
}

/////////////////////////////////////////////////////////////////////
//                                                                 //
//  Method: subtact(), subtracts operand2 from operand1            //
//                                                                 //
/////////////////////////////////////////////////////////////////////

void BigNumber::subtract(){
	int carry = 0;			// carry from previous operation			

	for(int i = 0; i < OP_SIZE; i++){ 
		if((operand1[i] - carry)< operand2[i]){
			// if carry set subtact 1 from operand1
			if(carry == 1){
				operand1[i]--;
			}
			operand1[i] += 16; 
			result[i] = operand1[i] - operand2[i];
			carry = 1;
		}
		else if((operand1[i] - carry) > operand2[i]){
			// if carry set subtact 1 from operand1
			if(carry == 1){
				operand1[i]--;
			}
			result[i] = operand1[i] - operand2[i];
			carry = 0;
		}
		else if((operand1[i] - carry) == operand2[i]){
			// if carry set subtact 1 from operand1
			if(carry == 1){
				operand1[i]--;
			}
			result[i] = operand1[i] - operand2[i];
			carry = 0;
		}
	}
}

/////////////////////////////////////////////////////////////////////
//                                                                 //
//  Method: multiply(), multiplys the two operands.                //
//                                                                 //
/////////////////////////////////////////////////////////////////////

void BigNumber::multiply(){
	int carry = 0;
	int i = 0;
	bool cont_add = true;
	
	while(cont_add){
		for(i = 0; i < OP_SIZE; i++){
			if((operand1[i] + carry + result[i]) > 15){
				if(carry == 1){
					result[i] += carry;
				}
				result[i] += operand1[i];
				result[i] = result[i] % 16;
				carry = 1;
			}
			else if((operand1[i]+ carry + result[i]) <= 15){
				if(carry == 1){
					result[i] += carry;
				}
				result[i] += operand1[i];
				carry = 0;
			}
		}
		i = 0;
	    // subtact one from operand2
		if((--operand2[i]) < 0){
			// borrow one if 0
			while((operand2[i]) < 0){
			    operand2[i] = 15;
				operand2[i + 1] -= 1; 
				i++;
			}
		}
		// check if operand2 is all zeros
		for(i = 0; i < OP_SIZE; i++){
			if(operand2[i] != 0){
				cont_add = true;
				break;
			}
			else{
				cont_add = false;
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////
//                                                                 //
//  Method: divides(), divides the two operands.                   //
//                                                                 //
/////////////////////////////////////////////////////////////////////
void BigNumber::divide(){
	int carry = 0;			// sum of operation
	bool op1_greater_op2 = true;

	while(op1_greater_op2){
		// subtact operand2 from operand1
		for(int i = 0; i < OP_SIZE; i++){ 
			if((operand1[i] - carry)< operand2[i]){
				// if carry set subtact 1 from operand1
				if(carry == 1){
					operand1[i]--;
				}
				operand1[i] += 16; 
				operand1[i] -= operand2[i];
				carry = 1;
			}
			else if((operand1[i] - carry) > operand2[i]){
				// if carry set subtact 1 from operand1
				if(carry == 1){
					operand1[i]--;
				}
				operand1[i] -= operand2[i];
				carry = 0;
			}
			else if((operand1[i] - carry) == operand2[i]){
				// if carry set subtact 1 from operand1
				if(carry == 1){
					operand1[i]--;
				}
				operand1[i] -= operand2[i];
				carry = 0;
			}
		}

		i = 0;
		// add 1 to the to the result for the division operation
		if((result[i] + 1) > 15){
			while((result[i] + 1) > 15){
				result[i] += 1;
			    result[i] = result[i] % 16;
				result[i + 1] += 1; 
				i++;
			}
		}
		else {
			result[i] += 1;
		}
	
		// check the leading digit in operand1 
		// if it is less than operand 2 to stop dividing
		for(int j = OP_SIZE - 1; j >= 0; j--){
			if((operand1[j] == 0) && (operand2[j] == 0)){
				continue;
			}
			else if(operand1[j] >= operand2[j]){
				op1_greater_op2 = true;
				break;
			}
			else if(operand1[j] < operand2[j]){
				op1_greater_op2 = false;
				break;
			}
		}
	}
}
/////////////////////////////////////////////////////////////////////
//                                                                 //
//  Method: power(), raises operand1 to the power of operand2.     //
//                                                                 //
/////////////////////////////////////////////////////////////////////

void BigNumber::power(){
	int carry = 0;					// carry from add operation
	int i = 0;						// index into arrays
	
	int op1_temp[OP_SIZE];			// temp value holding operand1
	int result_temp[OP_SIZE];		// temp value holding result

	bool cont_add = true;			// continue adding
	bool cont_mult = true;			// continue multiplying
	bool first_time = true;			// first time the thru method
	bool first_mult = true;			// first time to muliply

	while(cont_mult){
		if(first_time){
			for(i = 0; i < OP_SIZE; i++){
				op1_temp[i] = operand1[i];	
			}
		}
		else{
			for(i = 0; i < OP_SIZE; i++){
				first_mult = true;
				op1_temp[i] = operand1[i];	
				result_temp[i] = result[i];
			}
		}
		while(cont_add){
			if(first_time){
				// if the first time to add, add operand1 to result
				for(i = 0; i < OP_SIZE; i++){
					if((operand1[i] + carry + result[i]) > 15){
						if(carry == 1){
							result[i] += carry;
						}
						result[i] += operand1[i];
						result[i] = result[i] % 16;
						carry = 1;
					}
					else if((operand1[i]+ carry + result[i]) <= 15){
						if(carry == 1){
							result[i] += carry;
						}
						result[i] += operand1[i];
						carry = 0;
					}
				}
			} 
			else {
				for(i = 0; i < OP_SIZE; i++){
					if((result_temp[i] + carry + result[i]) > 15){
						if(carry == 1){
							result[i] += carry;
						}
						result[i] += result_temp[i];
						result[i] = result[i] % 16;
						carry = 1;
					}
					else if((result_temp[i] + carry + result[i]) <= 15){
						if(carry == 1){
							result[i] += carry;
						}
						result[i] += result_temp[i];
						carry = 0;
					}
				}
			}

			
			if(first_mult && !first_time){
				i = 0;
				if((--op1_temp[i]) < 0){
				// borrow one if 0
					while((op1_temp[i]) < 0){
						op1_temp[i] = 15;
						op1_temp[i + 1] -= 1; 
						i++;
					}
				}
				first_mult = false;
			}

			// subtact one from operand1
			i = 0;
		    if((--op1_temp[i]) < 0){
			// borrow one if 0
				while((op1_temp[i]) < 0){
					op1_temp[i] = 15;
					op1_temp[i + 1] -= 1; 
					i++;
				}
			}
			
			// check if operand1 is all zeros
			for(i = 0; i < OP_SIZE; i++){
				if(op1_temp[i] != 0){
					cont_add = true;
					break;
				}
				else{
					cont_add = false;
				}
			}
		}
		cont_add = true;

		i = 0;
		if(first_time && (operand2[i] > 1)){
			--operand2[i];
		}
		first_time = false;

		// subtact one from operand2
		if((--operand2[i]) < 0){
		// borrow one if 0
			while((operand2[i]) < 0){
				operand2[i] = 15;
				operand2[i + 1] -= 1; 
				i++;
			}
		}

		// check if operand2 is all zeros
		for(i = 0; i < OP_SIZE; i++){
			if(operand2[i] != 0){
				cont_mult = true;
				break;
			}
			else{
				cont_mult = false;
			}
		} 
	}
}

/////////////////////////////////////////////////////////////////////
//                                                                 //
//  Method: hex_to_dec converts a hex character to it decimal      //
//  equivalent.                                                    //
//                                                                 //
/////////////////////////////////////////////////////////////////////

int BigNumber::hex_to_dec(char hex_num){
    int number;           // decimal number to return
    
	// chack for a number
    if((hex_num >= 48) && (hex_num <= 57)){
        number = hex_num - 48;
    }
	// check for upper case letters A through F
    else if((hex_num >= 65) && (hex_num <= 70)){
        number = hex_num - 55;
	}
	// check for lower case letters a through f
    else if((hex_num >= 97) && (hex_num <= 102)){
        number = hex_num - 87;
    } 
	// the character is not a hex digit
	else {
		number = 0;
        cerr << "Incorrect format for the line\n";
    }
    return number;
}



