//////////////////////////////////////////////////////////////////////
//                                                                  //
//  Nathan Balon                                                    //
//  SN #3210 1717                                                   //
//                                                                  //
//  Program #3                                                      //
//  CIS 310                                                         //
//  Winter 2004                                                     //
//                                                                  //
//  BigNumber1.h: interface for the BigNumber class.                //
//                                                                  //
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BIGNUMBER1_H__F92B447A_65BD_46AC_9D83_D3F035F2301E__INCLUDED_)
#define AFX_BIGNUMBER1_H__F92B447A_65BD_46AC_9D83_D3F035F2301E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define OP_SIZE 40
#include <string>
#include <iostream>

using namespace std;

class BigNumber {


public:
	BigNumber(char* line);               // constructor with line read from file
	virtual ~BigNumber();                // destructor                
    void operation();                    // the operation to be performed

private:
	// private methods
    int hex_to_dec(char hex_num);        // convert a Hex char to a dec integer
	void add();                          // add the 2 operands
	void subtract();                     // subtract the 2 operands
	void multiply();                     // multiply the 2 operands
	void divide();                       // divide the 2 operands
	void power();                        // take the operand1 to the power of operand2

	// private data
    int operand1[OP_SIZE];               // first operand  
    int operand2[OP_SIZE];               // second operand
	int op1_size;                        // size of first operand
	int op2_size;                        // size of second operand
	int result[OP_SIZE];                 // the result of the operation
	char op;                             // the operator to be used



	
	// friend function output the result of the operation
	friend ostream& operator<<(ostream& os,const BigNumber & num){
		bool found_num = false;       // if a hex number is found
		char hex_char[] = {'0', '1', '2', '3', '4', '5', '6', '7',
		               '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
		int remainder =0;

		// convert an decimal number to a hex number
		for(int i = OP_SIZE - 1; i >= 0; i--){
			if((num.result[i] == 0) && (found_num == false)){
				continue;
			}
			else{
				remainder = num.result[i] % 16;
				os << hex_char[remainder];
				found_num = true;
			}
		}

		found_num = false;
		// if division operation print the remainder
		if(num.op == '/'){
			os << ", Remainder=";
			for(int i = OP_SIZE - 1; i >= 0; i--){
				if((num.operand1[i] == 0) && (found_num == false)){
					continue;
				}
				else{
					remainder = num.operand1[i] % 16;
					os << hex_char[remainder];
					found_num = true;
				}
			}
			// if the remainder was zero print a 0
			if(found_num == false){
				os << 0;
			}
		}
		return os;
	}


};

#endif // !defined(AFX_BIGNUMBER1_H__F92B447A_65BD_46AC_9D83_D3F035F2301E__INCLUDED_)
