//////////////////////////////////////////////////////////////////////
//                                                                  //
//  Nathan Balon                                                    //
//  SN #3210 1717                                                   //
//  CIS 310                                                         //
//  Winter 2004                                                     //
//                                                                  //
//  Program #3                                                      //
//                                                                  //
//  The program read lines from a file supplied by the user.        //
//  The line contains two operands and an operator to be applied    //
//  to them.  The class BigNumber is used to implement the          //
//  operations: add, subtact, multiple, devide and power.  The      //
//  operands contain up to 40 hexidecimal characters. After the     //
//  operation the files are read back to another file which is      //
//  specified by the user.                                          //
//                                                                  //
//  To run the program:                                             //
//                         prog3 input_file output_file             //
//                                                                  //
//////////////////////////////////////////////////////////////////////

#include <iostream>
#include <fstream>
#include <string>
#include "BigNumber1.h"
using namespace std;

#define LINE_SIZE 83

int main(int argc, char *argv[]){
    char line[LINE_SIZE];                  // line read in from file
    ifstream data_file;                    // file to read in
    ofstream out_file;                     // file to write to

    // check that the filename was supplied
    if(argc != 3){
        cerr << "USAGE: prog3 [input_filename] [output_filename]\n";
        exit(0);
   }

    // open the file to read from
    data_file.open(argv[1], ios::in);
    if(! data_file){
       cerr << "Cannot open the file\n";
       exit(1);
    }         

    // open the file to write to
    out_file.open(argv[2], ios::out);
    if(! out_file){
       cerr << "Unable to create a file to save results to\n";    
    }

    while(data_file >> line){
		BigNumber num(line);
		num.operation();
		cout << line << num << "\n";
		out_file << line << num << "\n";
	}

    // close the files
    data_file.close();
    out_file.close();
	return 0;
}
